diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
index 595fd82e4..ce99a00f2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
@@ -5,48 +5,43 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaBushy
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaTall;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicSaplingPine extends BlockLogicSaplingBase
-{
+public class BlockLogicSaplingPine extends BlockLogicSaplingBase {
 
-	public BlockLogicSaplingPine(@NotNull Block<?> block)
-    {
+    public BlockLogicSaplingPine(@NotNull Block<?> block) {
         super(block);
     }
 
     @Override
-    public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
-        if(world.isClientSide) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (world.isClientSide) {
             return;
         }
         super.updateTick(world, tilePos, rand, isRandomTick);
         int growthRate = 30;
-        if(world.getBlockLightValue(tilePos.up()) >= 9 && rand.nextInt(growthRate) == 0) {
+        if (world.getBlockLightValue(tilePos.up(new TilePos())) >= 9 && rand.nextInt(growthRate) == 0) {
             int l = world.getBlockData(tilePos);
-            if((l & 8) == 0)
-            {
+            if ((l & 8) == 0) {
                 world.setBlockDataNotify(tilePos, l | 8);
-            } else
-            {
+            } else {
                 growTree(world, tilePos, rand);
             }
         }
     }
-    
+
     @Override
-	public void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random)
-    {
-        WorldFeature treeBig  = new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
+    public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
+        WorldFeature treeBig = new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
         WorldFeature treeSmall = new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
-        
-    	world.setBlockId(tilePos, 0);
 
-        if(!treeSmall.place(world, random, tilePos.x, tilePos.y, tilePos.z))
-        {
-            if(!treeBig.place(world, random, tilePos.x, tilePos.y, tilePos.z)) {
+        world.setBlockId(tilePos, 0);
+
+        if (!treeSmall.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
+            if (!treeBig.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
                 world.setBlockId(tilePos, id());
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java
index 7582d6478..653b78f5f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java
@@ -4,30 +4,26 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 import net.minecraft.core.world.generate.feature.WorldFeature;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicSaplingRetro extends BlockLogicSaplingBase
-{
+public class BlockLogicSaplingRetro extends BlockLogicSaplingBase {
 
-	public BlockLogicSaplingRetro(@NotNull Block<?> block)
-    {
+    public BlockLogicSaplingRetro(@NotNull Block<?> block) {
         super(block);
     }
 
 
     @Override
-	public void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random)
-    {
-        WorldFeature treeBig  = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id(), Blocks.LOG_OAK.id());
+    public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
+        WorldFeature treeBig = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id(), Blocks.LOG_OAK.id());
         WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK_RETRO.id(), Blocks.LOG_OAK.id(), 4);
         world.setBlockId(tilePos, 0);
 
-        if(!treeSmall.place(world, random, tilePos.x, tilePos.y, tilePos.z))
-        {
-            if(!treeBig.place(world, random, tilePos.x, tilePos.y, tilePos.z)) {
+        if (!treeSmall.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
+            if (!treeBig.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
                 world.setBlockId(tilePos, id());
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java
index 854c9d827..a6907c3b7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java
@@ -3,29 +3,25 @@ package net.minecraft.core.block;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeShrub;
 import net.minecraft.core.world.generate.feature.WorldFeature;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicSaplingShrub extends BlockLogicSaplingBase
-{
+public class BlockLogicSaplingShrub extends BlockLogicSaplingBase {
 
-	public BlockLogicSaplingShrub(@NotNull Block<?> block)
-    {
+    public BlockLogicSaplingShrub(@NotNull Block<?> block) {
         super(block);
     }
-    
+
     @Override
-	public void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random)
-    {
+    public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
 
         world.setBlockId(tilePos, 0);
 
         WorldFeature tree = new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id(), Blocks.LOG_OAK.id());
-        
-        if(!tree.place(world, random, tilePos.x, tilePos.y, tilePos.z))
-        {
+
+        if (!tree.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
             world.setBlockId(tilePos, id());
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java
index 128b04eb4..f34a16586 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java
@@ -3,29 +3,25 @@ package net.minecraft.core.block;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeThorn;
 import net.minecraft.core.world.generate.feature.WorldFeature;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicSaplingThorn extends BlockLogicSaplingBase
-{
+public class BlockLogicSaplingThorn extends BlockLogicSaplingBase {
 
-    public BlockLogicSaplingThorn(@NotNull Block<?> block)
-    {
+    public BlockLogicSaplingThorn(@NotNull Block<?> block) {
         super(block);
     }
 
 
     @Override
-    public void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random)
-    {
+    public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
 
         world.setBlockId(tilePos, 0);
         WorldFeature treeFeature = new WorldFeatureTreeThorn(1, Blocks.LOG_THORN.id(), 0, Blocks.LEAVES_THORN.id(), 0);
 
-        if(!treeFeature.place(world, random, tilePos.x, tilePos.y, tilePos.z))
-        {
+        if (!treeFeature.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
             world.setBlockId(tilePos, id());
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
index 62cbb55e3..5e0f1cdd4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntitySeat;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
@@ -12,20 +12,21 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockLogicSeat extends BlockLogic
 {
     public BlockLogicSeat(@NotNull Block<?> block) {
-        super(block, Material.wood);
+        super(block, Materials.WOOD);
         setBlockBounds(0f, 0f, 0f, 1f, 9f / 16f, 1f);
         block.withEntity(() -> new TileEntitySeat(block));
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
-        if (world.isBlockNormalCube(tilePos.up())) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+        if (world.isBlockNormalCube(tilePos.up(new TilePos()))) {
             return false;
         }
         if (!world.isClientSide) {
@@ -39,7 +40,7 @@ public class BlockLogicSeat extends BlockLogic
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         if (!world.isClientSide) {
             TileEntitySeat tileEntity = (TileEntitySeat) world.getTileEntity(tilePos);
             if (tileEntity != null && tileEntity.getPassenger() != null) {
@@ -60,7 +61,7 @@ public class BlockLogicSeat extends BlockLogic
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index b18509550..4333eb06e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -4,6 +4,7 @@ import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
@@ -13,15 +14,16 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
-public class BlockLogicSign extends BlockLogic implements IPaintable
-{
+public class BlockLogicSign extends BlockLogic implements IPaintable {
     public static final int MASK_SIDE = 0b0000_1111;
     public static final int SIDE_NORTH = 2;
     public static final int SIDE_SOUTH = 3;
@@ -29,8 +31,8 @@ public class BlockLogicSign extends BlockLogic implements IPaintable
     public static final int SIDE_EAST = 5;
     public final boolean isFreeStanding;
 
-	public BlockLogicSign(@NotNull Block<?> block, boolean isFreeStanding) {
-        super(block, Material.wood);
+    public BlockLogicSign(@NotNull Block<?> block, boolean isFreeStanding) {
+        super(block, Materials.WOOD);
         this.isFreeStanding = isFreeStanding;
         float f = 0.25F;
         float f1 = 1.0F;
@@ -39,13 +41,13 @@ public class BlockLogicSign extends BlockLogic implements IPaintable
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
-        if(this.isFreeStanding) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        if (this.isFreeStanding) {
             return getBounds();
         }
         float bottom = 4.5f / 16f;
@@ -53,33 +55,31 @@ public class BlockLogicSign extends BlockLogic implements IPaintable
         float width = 1.0f;
         float thickness = 2.0f / 16f;
         return switch (source.getBlockData(tilePos) & MASK_SIDE) {
-            case SIDE_NORTH -> AABB.fromPool(0.0F, bottom, 1.0F - thickness, width, top, 1.0F);
-            case SIDE_SOUTH -> AABB.fromPool(0.0F, bottom, 0.0F, width, top, thickness);
-            case SIDE_WEST -> AABB.fromPool(1.0F - thickness, bottom, 0.0F, 1.0F, top, width);
-            case SIDE_EAST -> AABB.fromPool(0.0F, bottom, 0.0F, thickness, top, width);
-            default -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            case SIDE_NORTH -> new AABBd(0.0F, bottom, 1.0F - thickness, width, top, 1.0F);
+            case SIDE_SOUTH -> new AABBd(0.0F, bottom, 0.0F, width, top, thickness);
+            case SIDE_WEST -> new AABBd(1.0F - thickness, bottom, 0.0F, 1.0F, top, width);
+            case SIDE_EAST -> new AABBd(0.0F, bottom, 0.0F, thickness, top, width);
+            default -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         };
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public @NotNull Side getAttachedSide(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull Side getAttachedSide(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return switch (source.getBlockData(tilePos) & MASK_SIDE) {
             case SIDE_NORTH -> Side.SOUTH;
             case SIDE_SOUTH -> Side.NORTH;
@@ -90,24 +90,23 @@ public class BlockLogicSign extends BlockLogic implements IPaintable
     }
 
     @Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id)
-    {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+        TilePos queryPos = new TilePos();
         boolean isUnstable = false;
-        if(this.isFreeStanding) {
-            if(!world.getBlockMaterial(tilePos.down()).isSolid()) {
+        if (this.isFreeStanding) {
+            if (!world.getBlockMaterial(tilePos.down(queryPos)).isSolid()) {
                 isUnstable = true;
             }
         } else {
             isUnstable = switch (world.getBlockData(tilePos) & MASK_SIDE) {
-                case SIDE_NORTH -> !world.getBlockMaterial(tilePos.add(Direction.SOUTH)).isSolid();
-                case SIDE_SOUTH -> !world.getBlockMaterial(tilePos.add(Direction.NORTH)).isSolid();
-                case SIDE_WEST -> !world.getBlockMaterial(tilePos.add(Direction.EAST)).isSolid();
-                case SIDE_EAST -> !world.getBlockMaterial(tilePos.add(Direction.WEST)).isSolid();
+                case SIDE_NORTH -> !world.getBlockMaterial(tilePos.add(Direction.SOUTH, queryPos)).isSolid();
+                case SIDE_SOUTH -> !world.getBlockMaterial(tilePos.add(Direction.NORTH, queryPos)).isSolid();
+                case SIDE_WEST -> !world.getBlockMaterial(tilePos.add(Direction.EAST, queryPos)).isSolid();
+                case SIDE_EAST -> !world.getBlockMaterial(tilePos.add(Direction.WEST, queryPos)).isSolid();
                 default -> true;
             };
         }
-        if(isUnstable)
-        {
+        if (isUnstable) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
         }
@@ -116,12 +115,12 @@ public class BlockLogicSign extends BlockLogic implements IPaintable
 
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
-        return new ItemStack[] { new ItemStack(Items.SIGN) };
+        return new ItemStack[]{new ItemStack(Items.SIGN)};
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
-        TileEntitySign signEntity = (TileEntitySign)world.getTileEntity(tilePos);
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+        TileEntitySign signEntity = (TileEntitySign) world.getTileEntity(tilePos);
         if (signEntity != null) {
             if (signEntity.isLocked()) return false;
             ItemStack heldItem = player.getHeldItem();
@@ -146,12 +145,12 @@ public class BlockLogicSign extends BlockLogic implements IPaintable
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         world.setBlockIdRaw(tilePos, this.isFreeStanding ? Blocks.SIGN_POST_PLANKS_OAK_PAINTED.id() : Blocks.SIGN_WALL_PLANKS_OAK_PAINTED.id());
         world.setBlockDataNotify(tilePos, color.blockMeta << 4 | (world.getBlockData(tilePos) & MASK_SIDE));
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java
index 6dc963ac4..e3f523833 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java
@@ -6,7 +6,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -32,12 +32,12 @@ public class BlockLogicSignPainted extends BlockLogicSign implements IPainted{
     }
 
     @Override
-    public void removeDye(@NotNull World world, @NotNull TilePos tilePos) {
+    public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
         world.setBlockDataNotify(tilePos, stripColorFromMetadata(world.getBlockData(tilePos)));
     }
 
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         world.setBlockDataNotify(tilePos, color.blockMeta << 4 | stripColorFromMetadata(world.getBlockData(tilePos)));
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
index 3a7dc9e2d..be8881bb9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
@@ -14,13 +15,15 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.block.ItemBlockSlab;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
@@ -40,7 +43,7 @@ public class BlockLogicSlab extends BlockLogic
     }
 
     public BlockLogicSlab(@NotNull Block<?> block, @NotNull Block<?> modelBlock, int modelBlockMetadata) {
-    	super(block, Material.stone);
+    	super(block, Materials.STONE);
         this.modelBlock = modelBlock;
         this.modelBlockMetadata = modelBlockMetadata;
         block.withLightBlock(1);
@@ -59,11 +62,11 @@ public class BlockLogicSlab extends BlockLogic
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return switch (source.getBlockData(tilePos) & MASK_STATE) {
-            case STATE_LOWER -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
-            case STATE_DOUBLE -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            default -> AABB.fromPool(0.0F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
+            case STATE_LOWER -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
+            case STATE_DOUBLE -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            default -> new AABBd(0.0F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
         };
     }
 
@@ -74,19 +77,19 @@ public class BlockLogicSlab extends BlockLogic
     }
 
     @Override
-    public boolean renderAsNormalBlockOnCondition(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public boolean renderAsNormalBlockOnCondition(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int meta = source.getBlockData(tilePos);
         return (meta & MASK_STATE) == STATE_DOUBLE;
     }
 
     @Override
-    public boolean canPlaceOnSurfaceOnCondition(@NotNull World world, @NotNull TilePos tilePos) {
+    public boolean canPlaceOnSurfaceOnCondition(@NotNull World world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
         return (meta & MASK_STATE) != STATE_LOWER;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int state = world.getBlockData(tilePos) & MASK_STATE;
         return switch (side) {
             case TOP -> state == STATE_UPPER || state == STATE_DOUBLE ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
@@ -125,8 +128,8 @@ public class BlockLogicSlab extends BlockLogic
     }
 
     @Override
-    public void onEntityInside(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity entity, @NotNull Vec3 velocity) {
-        this.modelBlock.onEntityInside(world, tilePos, entity, velocity);
+    public void onEntityInside(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity, @NotNull Vector3d velocityDirection) {
+        this.modelBlock.onEntityInside(world, tilePos, entity, velocityDirection);
     }
 
     @Override
@@ -142,29 +145,30 @@ public class BlockLogicSlab extends BlockLogic
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos) {
-        return world.getBlockId(tilePos.down()) == id() ||
-                world.getBlockId(tilePos.up()) == id() ||
+	public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        return world.getBlockId(tilePos.down(queryPos)) == id() ||
+                world.getBlockId(tilePos.up(queryPos)) == id() ||
                 super.canPlaceAt(world, tilePos);
     }
 
     @Override
-    public void onEntityWalkedOn(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity walker) {
+    public void onEntityWalkedOn(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity walker) {
         this.modelBlock.onEntityWalkedOn(world, tilePos, walker);
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
+	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         this.modelBlock.updateTick(world, tilePos, rand, false);
     }
 
     @Override
-    public void onDestroyedByExplosion(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onDestroyedByExplosion(@NotNull World world, @NotNull TilePosc tilePos) {
         this.modelBlock.onDestroyedByExplosion(world, tilePos);
     }
 
     @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, Mob mob, double xHit, double yHit) {
+    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
     	Direction dir = mob.getVerticalPlacementDirection(side, yHit);
     	if(dir == Direction.DOWN) {
             world.setBlockDataNotify(tilePos, 0);
@@ -175,7 +179,7 @@ public class BlockLogicSlab extends BlockLogic
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if(side == Side.TOP) {
             world.setBlockDataNotify(tilePos, 2);
         } else {
@@ -184,7 +188,7 @@ public class BlockLogicSlab extends BlockLogic
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         onNeighborChanged(world, tilePos, 0);
         this.modelBlock.onPlacedByWorld(world, tilePos);
     }
@@ -195,22 +199,22 @@ public class BlockLogicSlab extends BlockLogic
     }
 
     @Override
-    public float getBrightness(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public float getBrightness(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return this.modelBlock.getBrightness(source, tilePos);
     }
 
     @Override
-    public void onAttacked(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
+    public void onAttacked(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
         this.modelBlock.onAttacked(world, tilePos, player, side, xHit, yHit);
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         return this.modelBlock.onInteracted(world, tilePos, player, side, xHit, yHit);
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
+	public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         this.modelBlock.animationTick(world, tilePos, rand);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java
index b32e5fa16..fe9294690 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicSlabPaintable extends BlockLogicSlab implements IPaintable {
@@ -11,7 +11,7 @@ public class BlockLogicSlabPaintable extends BlockLogicSlab implements IPaintabl
     }
 
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockIdDataNotify(tilePos, Blocks.SLAB_PLANKS_PAINTED.id(), meta);
         Blocks.SLAB_PLANKS_PAINTED.getLogic().setColor(world, tilePos, color);
